#!/usr/bin/perl
################################################################################
# eRS (eRecommend Site)                             Version 1.1                #
# Copyright 2000 Frederic TYNDIUK (FTLS)            All Rights Reserved.       #
# E-Mail: tyndiuk@ftls.org                          Script License: GPL        #
# Created  01/10/2000                               Last Modified 01/15/2000   #
# Scripts Archive at:                               http://www.ftls.org/cgi/   #
################################################################################
# Function :  Allow visitors to send (Recommend) an e-mail message about your  #
# site to friends.                                                             #
################################################################################
################################################################################
# Necessary Variables:                                                         #
# The following variables should be set to define the locations                #
# and URLs of various files, as explained in the documentation.                #

use strict;
require 'cgi-lib.pl';

# General Options :
 my $DISPLAY_LANG = 'UK';  # Fr to use french message, else english.
 my $WEBMASTER_EMAIL = 'webmaster@your_dom.dom'; # Webmaster E-Mail


# Configure data dir and messages files names.
 my $DATA_DIR           = '/Absolute/path/to/data_dir/'; # data dir.
 my $LOG_FILE_NAME       = 'eRS_log.txt';                 # Log file name.
 my $MESSAGE_FILE_NAME   = 'eRS_messEn.txt';              # Message send file
 my $CONFIR_MESSAGE_NAME = 'eRS_messEn_cnf.txt';          # Confim message name.
 my $TEMPLATE_RESULT = $DATA_DIR.'template.html';
	# Template for result look.


# Configure Secure Options :
 my @REFERERS = ('http://www.mydom.dom'); # Witch web site can use this CGI.
 my $SEND_MAIL_TO_SENDER = 0;            # Send a confim message to sender.
 my $SEND_MAIL_BCC_WEBMASTER = 0;        # Send Bcc mail to webmaster for each post.
 my $DELAY = 10;                         # Minimum delais (Minutes) before
                                         # another message can be send by same IP.


# Configure Mail Command,
	# I you can prefer to use Mail::Sender module
 my $MAIL_CMD = '/usr/sbin/sendmail -t'; # Send Mail command (Unix Only)
 my $USE_SENDMAIL_UNIX = 1;
	# En : 1 Use unix sendmail command, 0 use Mail::Sender module
 	# Fr : 1 utilise la commande sendmail unix, 0 utilise le module Mail::Sender
#use Mail::Sender;
	# En: Uncomment, Only if you don't use Sendmail (NT)
    # Fr : Sortir commentaire, Seulement si vous n'utilisez pas senmail (NT)

# Nothing Below this line needs to be altered!                                 #
################################################################################
#    DO NOT EDIT ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU'RE DOING    #
################################################################################
my $VALUE_GENERATOR = 'eRS (eRecommend Site) v1.0 made by FTLS (TYNDIUK Frederic, http://www.ftls.org/)';
my $VALUE_DCREATION = &ConvDate('', '%D');
my $TIME = time;

my(%NAME_TITLE, @WEEK_DAYS, @MONTHS, %input);

print &PrintHeader;
&CheckReferer();

&ReadParse(\%input);
if ($input{'lg'}) { $DISPLAY_LANG = $input{'lg'}; }

if ($DISPLAY_LANG eq 'Fr') {
	%NAME_TITLE = ('Bad_MailTo' => "L'E-Mail de votre ami (Value_data) n'est pas valide",
	'Bad_MailFrom' => "Votre E-Mail (Value_data) n'est pas valided",
	'Bad_Delay' => "Vous devez attendre quelques minutes avant d'envoyer un autre mail",
	'Mail_Send' => 'E-Mail Envoy');
	@WEEK_DAYS = ('Dimanche', 'Lundi', 'Mardi', 'Mercredi', 'Jeudi', 'Vendredi', 'Samedi');
	@MONTHS    = ('Janvier','F&eacute;vrier','Mars','Avril','Mai','Juin','Juillet','Ao&ucirc;t','Septembre','Octobre','Novembre','D&eacute;cembre');
} else {
	%NAME_TITLE = ('Bad_MailTo' => 'Your friend E-Mail (Value_data) is not valid',
	'Bad_MailFrom' => 'Your E-Mail (Value_data) is not valid',
	'Bad_Delay' => 'You should wait few minutes before send another Mail',
	'Mail_Send' => 'E-Mail Sended');
	@WEEK_DAYS = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
	@MONTHS    = ('January','February','March','April','May','June','July','August','September','October','November','December');
}

my $MailTo = $input{'mailto'};  $MailTo   =~ s/[^\w\.\@-]//g;
my $MailFrom = $input{'mails'}; $MailFrom =~ s/[^\w\.\@-]//g;
my $NameTo = $input{'mailnto'};
my $NameFrom = $input{'mailns'};

my $logline = "$ENV{'REMOTE_ADDR'}\t$ENV{'REMOTE_ADDR'}\t$MailFrom ($NameFrom)\t$MailTo ($NameTo)\t$TIME\t$VALUE_DCREATION\n";
my ($ip, $ns, $mt, $ms, $t);

	if (! &ControlMail($MailTo)) {
		$NAME_TITLE{'Bad_MailTo'} =~ s/Value_data/$MailTo/;
		&PrintResultPage_Exit($NAME_TITLE{'Bad_MailTo'}, ''); 
	}

	if (! &ControlMail($MailFrom)) {
		$NAME_TITLE{'Bad_MailFrom'} =~ s/Value_data/$MailFrom/;
		&PrintResultPage_Exit($NAME_TITLE{'Bad_MailFrom'}, ''); 
	}

	foreach (&Read_Data_File($DATA_DIR.$LOG_FILE_NAME)) {
		if (/^$ENV{'REMOTE_ADDR'}/) {
			($ip, $ns, $mt, $ms, $t) = split /\t|\n/, $_;
			if ($TIME - $t - 60 * $DELAY < 0) {
				&PrintResultPage_Exit($NAME_TITLE{'Bad_Delay'}, ''); 
			}
		}
	}
		
	open(OUTEND, ">>$DATA_DIR$LOG_FILE_NAME") || print "Cannot write log file $LOG_FILE_NAME, error: $!<BR>\n";
	print OUTEND $logline;
	close(OUTEND);

	my $txt = &SendMailFile($DATA_DIR.$MESSAGE_FILE_NAME);

	if ($SEND_MAIL_TO_SENDER) {
		sleep(1);  # wait 1s
		&SendMailFile($DATA_DIR.$CONFIR_MESSAGE_NAME);
	}

	&PrintResultPage_Exit($NAME_TITLE{'Mail_Send'}, $txt);

################################################################################
# Subs                                                                         #
################################################################################

sub CheckReferer {
	if (defined $ENV{'HTTP_REFERER'}) {
		foreach $_ (@REFERERS) {
			if ($ENV{'HTTP_REFERER'} =~ /^$_/i) {
				return;
        	}
		}
	}
	&PrintResultPage_Exit("Unauthorized access to: $ENV{'HTTP_REFERER'}", '')
}

sub ControlMail {
	my($email) = @_;
	if ($email =~ /;/) { return 0; }
	return $email =~ /^[\w-\.]+@[\w-\.]+\.\w+\s*$/;
}

sub SendMailFile {
	my($file_name) = @_;
	my($subject, $mailhead, $message, $ct, $mailer);
	$_ = join ('', &Read_Data_File($file_name));
	$_ =~ s/Value_MailTo/$MailTo/gi;
	$_ =~ s/Value_MailFrom/$MailFrom/gi;
	$_ =~ s/Value_NameTo/$NameTo/gi;
	$_ =~ s/Value_NameFrom/$NameFrom/gi;
	$_ =~ s/Value_Date/$VALUE_DCREATION/gi;
	$_ =~ s/Value_IP/$ENV{'REMOTE_ADDR'}/gi;
	$_ =~ s/Subject:(.*)\n//;
	if ($message =~ /<HTML>/i) { $ct = 'multipart/alternative;'	} else { $ct = 'text/plain; charset=iso-8859-1'; }
	$subject = $1;
	$message = $_."\n--\nSend with eRS (eRecommend Site) made by FTLS - http://www.ftls.org/";
	if ($USE_SENDMAIL_UNIX) {
#Organization:
	$mailhead = <<TAG;
To: $MailTo
From: $MailFrom
Subject: $subject
X-Ident-From: unknown
X-Mailer: FTLS's eRS (eRecommend Site) v1.0, http://www.ftls.org/ posted from $ENV{'SERVER_NAME'}
X-Webmaster: $WEBMASTER_EMAIL
X-From: Server Name:$ENV{'REMOTE_HOST'} / IP: $ENV{'REMOTE_ADDR'}
MIME-Version: 1.0
Content-Type: $ct
Precedence: bulk
TAG
		if ($SEND_MAIL_BCC_WEBMASTER) { $mailhead .= "Bcc: $WEBMASTER_EMAIL"; }
		open(MAIL,"|$MAIL_CMD $MailTo") ||  print("Could not execute \"$MAIL_CMD\"");
		print MAIL $mailhead."\n\n".$message;
		close(MAIL);
	} else {
		$Mail::Sender::NO_X_MAILER  = "";
		$Mail::Sender::SITE_HEADERS = "X-Sender: $ENV{'REMOTE_ADDR'} via $ENV{'SERVER_NAME'}";
		$mailer = new Mail::Sender {'from' => $MailFrom, 'smtp' => "localhost"} || print "Can't open mail module: $Mail::Sender::Error\n";
		if ($SEND_MAIL_BCC_WEBMASTER) {
			$mailer->MailMsg({ 'to' => $MailTo, 'subject' => $subject, 'msg' => $message }) || print "Can't send mail: $Mail::Sender::Error\n";
		} else {
			$mailer->MailMsg({ 'to' => $MailTo, 'subject' => $subject, 'bcc' => $WEBMASTER_EMAIL, 'msg' => $message }) || print "Can't send mail: $Mail::Sender::Error\n";
		}
		$mailer->Close;
	}
	return "<PRE>From: $MailFrom\nTo: $MailTo\nSubject: $subject\n\n$message</PRE>";
}

sub Read_Data_File {
	my($file) = @_;
	my @data;
	open(IN, "$file") || print "Cannot open file $file, error: $!\n" || exit;
	@data = <IN>;
	close(IN);
	return @data;
}

sub PrintResultPage_Exit {
	my($title, $message) = @_;
	$_ = join ('', &Read_Data_File($TEMPLATE_RESULT));
	$_ =~ s/Value_title/$title/gi;
	$_ =~ s/Value_message/$message/gi;
	$_ =~ s/Value_Author/$VALUE_GENERATOR/gi;
	$_ =~ s/Value_Generator/$VALUE_GENERATOR/gi;
	$_ =~ s/Value_DCreation/$VALUE_DCREATION/gi;
	print $_;
	exit;
}

sub ConvDate {
	my($time, $format) = @_;
	if (! $time)   { $time = time; }
	if (! $format) { $format = '%D' }
	my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($time);
	my $full_en_text_date = localtime($time);
	$mon++;
	my $yearl = $year + 1900;
	if ($year > 99) { $year -= 100; }
	my ($short_mon) = substr($MONTHS[$mon-1],  0, 3);
	my ($short_wday) = substr($WEEK_DAYS[$wday], 0, 3);
	my $mdayl = sprintf('%02d', $mday);
	my $monl  = sprintf('%02d', $mon);
	$sec   = sprintf('%02d', $sec);
	$min   = sprintf('%02d', $min);
	$hour  = sprintf('%02d', $hour);
	$year  = sprintf('%02d', $year);

	$_ = $format;
	s/%%/%/g;
	s/%a/$short_wday/g;
	s/%A/$WEEK_DAYS[$wday]/g;
	s/%b|%h/$short_mon/g;
	s/%B/$MONTHS[$mon-1]/g;
	s/%c/$full_en_text_date/g;
	s/%d/$mdayl/g;
	s/%D|%x/$monl\/$mdayl\/$yearl/g;
	s/%e/$mday/g;
	s/%m/$monl/g;
	s/%H/$hour/g;
	s/%j/$yday/g;
	s/%M/$min/g;
	s/%S/$sec/g;
	s/%n/\n/g;
	s/%t/\t/g;
	s/%X|%T/$hour:$min:$sec/g;
	s/%y/$year/g;
	s/%Y/$yearl/g;
	return $_;
}
